Unit DE30R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE10_p;

procedure DE30R(M :Integer; XN :Real; var YN :Array of Real;
                var XK :Real; N :Integer; var A :Array of Real;
                var Y :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var IERR :Integer);

implementation

procedure DE30R(M :Integer; XN :Real; var YN :Array of Real;
                var XK :Real; N :Integer; var A :Array of Real;
                var Y :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var IERR :Integer);
var
I,J,L,I1,N0,B :Integer;
DL,H,RA :Real;
const
//C1D7 :Real = 0.1428571428571429;
//C7M1 :Integer = 6;
C1D7 :Extended = 0.71428571428571428571e-1;
C7M1 :Integer = 13;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39;
begin
IERR := 0;
if ( N < 1 ) 
 then goto _38;
DL := XK-XN;
XK := XN;
H := DL/(N);
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    A[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*H;
_1:
   end;
_2:
 end;
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M];
_3:
   end;
_4:
 end;
RA := C1D7;
I1 := C7M1;
_5:
for I:=1 to M do
 begin
  for J:=1 to M do
   begin
    E[(I-1)+(J-1)*M] := E[(I-1)+(J-1)*M]*RA;
_6:
   end;
  E[(I-1)+(I-1)*M] := E[(I-1)+(I-1)*M]+1.0;
_7:
 end;
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA+A[(I-1)+(J-1)*M]*E[(J-1)+(L-1)*M];
_8:
     end;
    R[I-1] := RA;
_9:
   end;
  for I:=1 to M do
   begin
    E[(I-1)+(L-1)*M] := R[I-1];
_10:
   end;
_11:
 end;
RA := 1.0/(I1);
I1 := I1-1;
if ( I1 <> 0 ) 
 then goto _5;
for I:=1 to M do
 begin
  E[(I-1)+(I-1)*M] := E[(I-1)+(I-1)*M]+1.0;
_12:
 end;
B := N;
N0 := N;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    R1[(I-1)+(J-1)*M] := 0.0;
_13:
   end;
  R1[(J-1)+(J-1)*M] := 1.0;
_14:
 end;
I1 := 1;
goto _24;
_15:
case I1 of
 1: goto _16;
 2: goto _20;
end;
_16:
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA+E[(I-1)+(J-1)*M]*E[(J-1)+(L-1)*M];
_17:
     end;
    R2[(I-1)+(L-1)*M] := RA;
_18:
   end;
_19:
 end;
I1 := 2;
goto _24;
_20:
for L:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA+R2[(I-1)+(J-1)*M]*R2[(J-1)+(L-1)*M];
_21:
     end;
    E[(I-1)+(L-1)*M] := RA;
_22:
   end;
_23:
 end;
I1 := 1;
_24:
N0 := B div 2;
if ( B-2*N0 = 0 ) 
 then goto _35;
case I1 of
 1: goto _25;
 2: goto _30;
end;
_25:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for L:=1 to M do
     begin
      RA := RA+E[(I-1)+(L-1)*M]*R1[(L-1)+(J-1)*M];
_26:
     end;
    R[I-1] := RA;
_27:
   end;
  for I:=1 to M do
   begin
    R1[(I-1)+(J-1)*M] := R[I-1];
_28:
   end;
_29:
 end;
goto _35;
_30:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    RA := 0.0;
    for L:=1 to M do
     begin
      RA := RA+R2[(I-1)+(L-1)*M]*R1[(L-1)+(J-1)*M];
_31:
     end;
    R[I-1] := RA;
_32:
   end;
  for I:=1 to M do
   begin
    R1[(I-1)+(J-1)*M] := R[I-1];
_33:
   end;
_34:
 end;
_35:
B := N0;
if ( B <> 0 ) 
 then goto _15;
for I:=1 to M do
 begin
  RA := 0.0;
  for J:=1 to M do
   begin
    RA := RA+R1[(I-1)+(J-1)*M]*YN[J-1];
_36:
   end;
  Y[I-1] := RA;
_37:
 end;
XK := XK+DL;
goto _39;
_38:
IERR := 65;
UTDE10(IERR,30);
_39:
end;

end.
